aboutsummaryrefslogtreecommitdiff
path: root/tests/functional/substitute-truncated-nar.sh
diff options
context:
space:
mode:
authoreldritch horrors <pennae@lix.systems>2024-04-06 22:08:58 +0200
committereldritch horrors <pennae@lix.systems>2024-06-23 11:52:49 +0000
commit39a1e248c9e7adea312c5b7e1743a8e55da63e6c (patch)
treeb49c7911ad537c1fe6731508535eda19d7c1e2c3 /tests/functional/substitute-truncated-nar.sh
parentf80d95e36dc08c796863680c9ecc6b8f495825b9 (diff)
libutil: remove sinkToSource eof callback
this is only used in one place, and only to set a nicer error message on EndOfFile. the only caller that actually *catches* this exception should provide an error message in that catch block rather than forcing support for setting error message so deep into the stack. copyStorePath is never called outside of PathSubstitutionGoal anyway, which catches everything. Change-Id: Ifbae8706d781c388737706faf4c8a8b7917ca278
Diffstat (limited to 'tests/functional/substitute-truncated-nar.sh')
-rw-r--r--tests/functional/substitute-truncated-nar.sh29
1 files changed, 29 insertions, 0 deletions
diff --git a/tests/functional/substitute-truncated-nar.sh b/tests/functional/substitute-truncated-nar.sh
new file mode 100644
index 000000000..1ac7efaf6
--- /dev/null
+++ b/tests/functional/substitute-truncated-nar.sh
@@ -0,0 +1,29 @@
+source common.sh
+
+BINARY_CACHE=file://$cacheDir
+
+build() {
+ nix-build --no-out-link "$@" --expr 'derivation {
+ name = "text";
+ system = builtins.currentSystem;
+ builder = "/bin/sh";
+ args = [ "-c" "echo some text to make the nar less empty > $out" ];
+ }'
+}
+
+path=$(build)
+nix copy --to "$BINARY_CACHE" "$path"
+nix-collect-garbage >/dev/null 2>&1
+
+nar=0bylmx35yjy2b1b4k7gjsl7i4vc03cpmryb41grfb1mp40n3hifl.nar.xz
+
+[ -e $cacheDir/nar/$nar ] || fail "long nar missing?"
+
+xzcat $cacheDir/nar/$nar > $TEST_HOME/tmp
+truncate -s $(( $(stat -c %s $TEST_HOME/tmp) - 10 )) $TEST_HOME/tmp
+xz < $TEST_HOME/tmp > $cacheDir/nar/$nar
+
+# Copying back '$path' from the binary cache. This should fail as it is truncated
+if build --option substituters "$BINARY_CACHE" --option require-sigs false -j0; then
+ fail "Importing a truncated nar should fail"
+fi